"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SdkError = exports.AllServiceErrors = void 0;
const commons_1 = require("@effect-aws/commons");
exports.AllServiceErrors = [
    "AuthorizationAlreadyExistsFault",
    "AuthorizationNotFoundFault",
    "AuthorizationQuotaExceededFault",
    "BackupPolicyNotFoundFault",
    "BlueGreenDeploymentAlreadyExistsFault",
    "BlueGreenDeploymentNotFoundFault",
    "CertificateNotFoundFault",
    "CreateCustomDBEngineVersionFault",
    "CustomAvailabilityZoneNotFoundFault",
    "CustomDBEngineVersionAlreadyExistsFault",
    "CustomDBEngineVersionNotFoundFault",
    "CustomDBEngineVersionQuotaExceededFault",
    "DBClusterAlreadyExistsFault",
    "DBClusterAutomatedBackupNotFoundFault",
    "DBClusterAutomatedBackupQuotaExceededFault",
    "DBClusterBacktrackNotFoundFault",
    "DBClusterEndpointAlreadyExistsFault",
    "DBClusterEndpointNotFoundFault",
    "DBClusterEndpointQuotaExceededFault",
    "DBClusterNotFoundFault",
    "DBClusterParameterGroupNotFoundFault",
    "DBClusterQuotaExceededFault",
    "DBClusterRoleAlreadyExistsFault",
    "DBClusterRoleNotFoundFault",
    "DBClusterRoleQuotaExceededFault",
    "DBClusterSnapshotAlreadyExistsFault",
    "DBClusterSnapshotNotFoundFault",
    "DBInstanceAlreadyExistsFault",
    "DBInstanceAutomatedBackupNotFoundFault",
    "DBInstanceAutomatedBackupQuotaExceededFault",
    "DBInstanceNotFoundFault",
    "DBInstanceNotReadyFault",
    "DBInstanceRoleAlreadyExistsFault",
    "DBInstanceRoleNotFoundFault",
    "DBInstanceRoleQuotaExceededFault",
    "DBLogFileNotFoundFault",
    "DBParameterGroupAlreadyExistsFault",
    "DBParameterGroupNotFoundFault",
    "DBParameterGroupQuotaExceededFault",
    "DBProxyAlreadyExistsFault",
    "DBProxyEndpointAlreadyExistsFault",
    "DBProxyEndpointNotFoundFault",
    "DBProxyEndpointQuotaExceededFault",
    "DBProxyNotFoundFault",
    "DBProxyQuotaExceededFault",
    "DBProxyTargetAlreadyRegisteredFault",
    "DBProxyTargetGroupNotFoundFault",
    "DBProxyTargetNotFoundFault",
    "DBSecurityGroupAlreadyExistsFault",
    "DBSecurityGroupNotFoundFault",
    "DBSecurityGroupNotSupportedFault",
    "DBSecurityGroupQuotaExceededFault",
    "DBShardGroupAlreadyExistsFault",
    "DBShardGroupNotFoundFault",
    "DBSnapshotAlreadyExistsFault",
    "DBSnapshotNotFoundFault",
    "DBSnapshotTenantDatabaseNotFoundFault",
    "DBSubnetGroupAlreadyExistsFault",
    "DBSubnetGroupDoesNotCoverEnoughAZs",
    "DBSubnetGroupNotAllowedFault",
    "DBSubnetGroupNotFoundFault",
    "DBSubnetGroupQuotaExceededFault",
    "DBSubnetQuotaExceededFault",
    "DBUpgradeDependencyFailureFault",
    "DomainNotFoundFault",
    "Ec2ImagePropertiesNotSupportedFault",
    "EventSubscriptionQuotaExceededFault",
    "ExportTaskAlreadyExistsFault",
    "ExportTaskNotFoundFault",
    "GlobalClusterAlreadyExistsFault",
    "GlobalClusterNotFoundFault",
    "GlobalClusterQuotaExceededFault",
    "IamRoleMissingPermissionsFault",
    "IamRoleNotFoundFault",
    "InstanceQuotaExceededFault",
    "InsufficientAvailableIPsInSubnetFault",
    "InsufficientDBClusterCapacityFault",
    "InsufficientDBInstanceCapacityFault",
    "InsufficientStorageClusterCapacityFault",
    "IntegrationAlreadyExistsFault",
    "IntegrationConflictOperationFault",
    "IntegrationNotFoundFault",
    "IntegrationQuotaExceededFault",
    "InvalidBlueGreenDeploymentStateFault",
    "InvalidCustomDBEngineVersionStateFault",
    "InvalidDBClusterAutomatedBackupStateFault",
    "InvalidDBClusterCapacityFault",
    "InvalidDBClusterEndpointStateFault",
    "InvalidDBClusterSnapshotStateFault",
    "InvalidDBClusterStateFault",
    "InvalidDBInstanceAutomatedBackupStateFault",
    "InvalidDBInstanceStateFault",
    "InvalidDBParameterGroupStateFault",
    "InvalidDBProxyEndpointStateFault",
    "InvalidDBProxyStateFault",
    "InvalidDBSecurityGroupStateFault",
    "InvalidDBShardGroupStateFault",
    "InvalidDBSnapshotStateFault",
    "InvalidDBSubnetGroupFault",
    "InvalidDBSubnetGroupStateFault",
    "InvalidDBSubnetStateFault",
    "InvalidEventSubscriptionStateFault",
    "InvalidExportOnlyFault",
    "InvalidExportSourceStateFault",
    "InvalidExportTaskStateFault",
    "InvalidGlobalClusterStateFault",
    "InvalidIntegrationStateFault",
    "InvalidOptionGroupStateFault",
    "InvalidResourceStateFault",
    "InvalidRestoreFault",
    "InvalidS3BucketFault",
    "InvalidSubnet",
    "InvalidVPCNetworkStateFault",
    "KMSKeyNotAccessibleFault",
    "MaxDBShardGroupLimitReached",
    "NetworkTypeNotSupported",
    "OptionGroupAlreadyExistsFault",
    "OptionGroupNotFoundFault",
    "OptionGroupQuotaExceededFault",
    "PointInTimeRestoreNotEnabledFault",
    "ProvisionedIopsNotAvailableInAZFault",
    "ReservedDBInstanceAlreadyExistsFault",
    "ReservedDBInstanceNotFoundFault",
    "ReservedDBInstanceQuotaExceededFault",
    "ReservedDBInstancesOfferingNotFoundFault",
    "ResourceNotFoundFault",
    "SNSInvalidTopicFault",
    "SNSNoAuthorizationFault",
    "SNSTopicArnNotFoundFault",
    "SharedSnapshotQuotaExceededFault",
    "SnapshotQuotaExceededFault",
    "SourceClusterNotSupportedFault",
    "SourceDatabaseNotSupportedFault",
    "SourceNotFoundFault",
    "StorageQuotaExceededFault",
    "StorageTypeNotAvailableFault",
    "StorageTypeNotSupportedFault",
    "SubnetAlreadyInUse",
    "SubscriptionAlreadyExistFault",
    "SubscriptionCategoryNotFoundFault",
    "SubscriptionNotFoundFault",
    "TenantDatabaseAlreadyExistsFault",
    "TenantDatabaseNotFoundFault",
    "TenantDatabaseQuotaExceededFault",
    "UnsupportedDBEngineVersionFault",
];
exports.SdkError = commons_1.SdkError;
//# sourceMappingURL=Errors.js.map