"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RDSService = exports.makeRDSService = void 0;
/**
 * @since 1.0.0
 */
const client_rds_1 = require("@aws-sdk/client-rds");
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Errors_js_1 = require("./Errors.js");
const Instance = __importStar(require("./RDSClientInstance.js"));
const RDSServiceConfig = __importStar(require("./RDSServiceConfig.js"));
const commands = {
    AddRoleToDBClusterCommand: client_rds_1.AddRoleToDBClusterCommand,
    AddRoleToDBInstanceCommand: client_rds_1.AddRoleToDBInstanceCommand,
    AddSourceIdentifierToSubscriptionCommand: client_rds_1.AddSourceIdentifierToSubscriptionCommand,
    AddTagsToResourceCommand: client_rds_1.AddTagsToResourceCommand,
    ApplyPendingMaintenanceActionCommand: client_rds_1.ApplyPendingMaintenanceActionCommand,
    AuthorizeDBSecurityGroupIngressCommand: client_rds_1.AuthorizeDBSecurityGroupIngressCommand,
    BacktrackDBClusterCommand: client_rds_1.BacktrackDBClusterCommand,
    CancelExportTaskCommand: client_rds_1.CancelExportTaskCommand,
    CopyDBClusterParameterGroupCommand: client_rds_1.CopyDBClusterParameterGroupCommand,
    CopyDBClusterSnapshotCommand: client_rds_1.CopyDBClusterSnapshotCommand,
    CopyDBParameterGroupCommand: client_rds_1.CopyDBParameterGroupCommand,
    CopyDBSnapshotCommand: client_rds_1.CopyDBSnapshotCommand,
    CopyOptionGroupCommand: client_rds_1.CopyOptionGroupCommand,
    CreateBlueGreenDeploymentCommand: client_rds_1.CreateBlueGreenDeploymentCommand,
    CreateCustomDBEngineVersionCommand: client_rds_1.CreateCustomDBEngineVersionCommand,
    CreateDBClusterCommand: client_rds_1.CreateDBClusterCommand,
    CreateDBClusterEndpointCommand: client_rds_1.CreateDBClusterEndpointCommand,
    CreateDBClusterParameterGroupCommand: client_rds_1.CreateDBClusterParameterGroupCommand,
    CreateDBClusterSnapshotCommand: client_rds_1.CreateDBClusterSnapshotCommand,
    CreateDBInstanceCommand: client_rds_1.CreateDBInstanceCommand,
    CreateDBInstanceReadReplicaCommand: client_rds_1.CreateDBInstanceReadReplicaCommand,
    CreateDBParameterGroupCommand: client_rds_1.CreateDBParameterGroupCommand,
    CreateDBProxyCommand: client_rds_1.CreateDBProxyCommand,
    CreateDBProxyEndpointCommand: client_rds_1.CreateDBProxyEndpointCommand,
    CreateDBSecurityGroupCommand: client_rds_1.CreateDBSecurityGroupCommand,
    CreateDBShardGroupCommand: client_rds_1.CreateDBShardGroupCommand,
    CreateDBSnapshotCommand: client_rds_1.CreateDBSnapshotCommand,
    CreateDBSubnetGroupCommand: client_rds_1.CreateDBSubnetGroupCommand,
    CreateEventSubscriptionCommand: client_rds_1.CreateEventSubscriptionCommand,
    CreateGlobalClusterCommand: client_rds_1.CreateGlobalClusterCommand,
    CreateIntegrationCommand: client_rds_1.CreateIntegrationCommand,
    CreateOptionGroupCommand: client_rds_1.CreateOptionGroupCommand,
    CreateTenantDatabaseCommand: client_rds_1.CreateTenantDatabaseCommand,
    DeleteBlueGreenDeploymentCommand: client_rds_1.DeleteBlueGreenDeploymentCommand,
    DeleteCustomDBEngineVersionCommand: client_rds_1.DeleteCustomDBEngineVersionCommand,
    DeleteDBClusterCommand: client_rds_1.DeleteDBClusterCommand,
    DeleteDBClusterAutomatedBackupCommand: client_rds_1.DeleteDBClusterAutomatedBackupCommand,
    DeleteDBClusterEndpointCommand: client_rds_1.DeleteDBClusterEndpointCommand,
    DeleteDBClusterParameterGroupCommand: client_rds_1.DeleteDBClusterParameterGroupCommand,
    DeleteDBClusterSnapshotCommand: client_rds_1.DeleteDBClusterSnapshotCommand,
    DeleteDBInstanceCommand: client_rds_1.DeleteDBInstanceCommand,
    DeleteDBInstanceAutomatedBackupCommand: client_rds_1.DeleteDBInstanceAutomatedBackupCommand,
    DeleteDBParameterGroupCommand: client_rds_1.DeleteDBParameterGroupCommand,
    DeleteDBProxyCommand: client_rds_1.DeleteDBProxyCommand,
    DeleteDBProxyEndpointCommand: client_rds_1.DeleteDBProxyEndpointCommand,
    DeleteDBSecurityGroupCommand: client_rds_1.DeleteDBSecurityGroupCommand,
    DeleteDBShardGroupCommand: client_rds_1.DeleteDBShardGroupCommand,
    DeleteDBSnapshotCommand: client_rds_1.DeleteDBSnapshotCommand,
    DeleteDBSubnetGroupCommand: client_rds_1.DeleteDBSubnetGroupCommand,
    DeleteEventSubscriptionCommand: client_rds_1.DeleteEventSubscriptionCommand,
    DeleteGlobalClusterCommand: client_rds_1.DeleteGlobalClusterCommand,
    DeleteIntegrationCommand: client_rds_1.DeleteIntegrationCommand,
    DeleteOptionGroupCommand: client_rds_1.DeleteOptionGroupCommand,
    DeleteTenantDatabaseCommand: client_rds_1.DeleteTenantDatabaseCommand,
    DeregisterDBProxyTargetsCommand: client_rds_1.DeregisterDBProxyTargetsCommand,
    DescribeAccountAttributesCommand: client_rds_1.DescribeAccountAttributesCommand,
    DescribeBlueGreenDeploymentsCommand: client_rds_1.DescribeBlueGreenDeploymentsCommand,
    DescribeCertificatesCommand: client_rds_1.DescribeCertificatesCommand,
    DescribeDBClusterAutomatedBackupsCommand: client_rds_1.DescribeDBClusterAutomatedBackupsCommand,
    DescribeDBClusterBacktracksCommand: client_rds_1.DescribeDBClusterBacktracksCommand,
    DescribeDBClusterEndpointsCommand: client_rds_1.DescribeDBClusterEndpointsCommand,
    DescribeDBClusterParameterGroupsCommand: client_rds_1.DescribeDBClusterParameterGroupsCommand,
    DescribeDBClusterParametersCommand: client_rds_1.DescribeDBClusterParametersCommand,
    DescribeDBClusterSnapshotAttributesCommand: client_rds_1.DescribeDBClusterSnapshotAttributesCommand,
    DescribeDBClusterSnapshotsCommand: client_rds_1.DescribeDBClusterSnapshotsCommand,
    DescribeDBClustersCommand: client_rds_1.DescribeDBClustersCommand,
    DescribeDBEngineVersionsCommand: client_rds_1.DescribeDBEngineVersionsCommand,
    DescribeDBInstanceAutomatedBackupsCommand: client_rds_1.DescribeDBInstanceAutomatedBackupsCommand,
    DescribeDBInstancesCommand: client_rds_1.DescribeDBInstancesCommand,
    DescribeDBLogFilesCommand: client_rds_1.DescribeDBLogFilesCommand,
    DescribeDBParameterGroupsCommand: client_rds_1.DescribeDBParameterGroupsCommand,
    DescribeDBParametersCommand: client_rds_1.DescribeDBParametersCommand,
    DescribeDBProxiesCommand: client_rds_1.DescribeDBProxiesCommand,
    DescribeDBProxyEndpointsCommand: client_rds_1.DescribeDBProxyEndpointsCommand,
    DescribeDBProxyTargetGroupsCommand: client_rds_1.DescribeDBProxyTargetGroupsCommand,
    DescribeDBProxyTargetsCommand: client_rds_1.DescribeDBProxyTargetsCommand,
    DescribeDBRecommendationsCommand: client_rds_1.DescribeDBRecommendationsCommand,
    DescribeDBSecurityGroupsCommand: client_rds_1.DescribeDBSecurityGroupsCommand,
    DescribeDBShardGroupsCommand: client_rds_1.DescribeDBShardGroupsCommand,
    DescribeDBSnapshotAttributesCommand: client_rds_1.DescribeDBSnapshotAttributesCommand,
    DescribeDBSnapshotTenantDatabasesCommand: client_rds_1.DescribeDBSnapshotTenantDatabasesCommand,
    DescribeDBSnapshotsCommand: client_rds_1.DescribeDBSnapshotsCommand,
    DescribeDBSubnetGroupsCommand: client_rds_1.DescribeDBSubnetGroupsCommand,
    DescribeEngineDefaultClusterParametersCommand: client_rds_1.DescribeEngineDefaultClusterParametersCommand,
    DescribeEngineDefaultParametersCommand: client_rds_1.DescribeEngineDefaultParametersCommand,
    DescribeEventCategoriesCommand: client_rds_1.DescribeEventCategoriesCommand,
    DescribeEventSubscriptionsCommand: client_rds_1.DescribeEventSubscriptionsCommand,
    DescribeEventsCommand: client_rds_1.DescribeEventsCommand,
    DescribeExportTasksCommand: client_rds_1.DescribeExportTasksCommand,
    DescribeGlobalClustersCommand: client_rds_1.DescribeGlobalClustersCommand,
    DescribeIntegrationsCommand: client_rds_1.DescribeIntegrationsCommand,
    DescribeOptionGroupOptionsCommand: client_rds_1.DescribeOptionGroupOptionsCommand,
    DescribeOptionGroupsCommand: client_rds_1.DescribeOptionGroupsCommand,
    DescribeOrderableDBInstanceOptionsCommand: client_rds_1.DescribeOrderableDBInstanceOptionsCommand,
    DescribePendingMaintenanceActionsCommand: client_rds_1.DescribePendingMaintenanceActionsCommand,
    DescribeReservedDBInstancesCommand: client_rds_1.DescribeReservedDBInstancesCommand,
    DescribeReservedDBInstancesOfferingsCommand: client_rds_1.DescribeReservedDBInstancesOfferingsCommand,
    DescribeSourceRegionsCommand: client_rds_1.DescribeSourceRegionsCommand,
    DescribeTenantDatabasesCommand: client_rds_1.DescribeTenantDatabasesCommand,
    DescribeValidDBInstanceModificationsCommand: client_rds_1.DescribeValidDBInstanceModificationsCommand,
    DisableHttpEndpointCommand: client_rds_1.DisableHttpEndpointCommand,
    DownloadDBLogFilePortionCommand: client_rds_1.DownloadDBLogFilePortionCommand,
    EnableHttpEndpointCommand: client_rds_1.EnableHttpEndpointCommand,
    FailoverDBClusterCommand: client_rds_1.FailoverDBClusterCommand,
    FailoverGlobalClusterCommand: client_rds_1.FailoverGlobalClusterCommand,
    ListTagsForResourceCommand: client_rds_1.ListTagsForResourceCommand,
    ModifyActivityStreamCommand: client_rds_1.ModifyActivityStreamCommand,
    ModifyCertificatesCommand: client_rds_1.ModifyCertificatesCommand,
    ModifyCurrentDBClusterCapacityCommand: client_rds_1.ModifyCurrentDBClusterCapacityCommand,
    ModifyCustomDBEngineVersionCommand: client_rds_1.ModifyCustomDBEngineVersionCommand,
    ModifyDBClusterCommand: client_rds_1.ModifyDBClusterCommand,
    ModifyDBClusterEndpointCommand: client_rds_1.ModifyDBClusterEndpointCommand,
    ModifyDBClusterParameterGroupCommand: client_rds_1.ModifyDBClusterParameterGroupCommand,
    ModifyDBClusterSnapshotAttributeCommand: client_rds_1.ModifyDBClusterSnapshotAttributeCommand,
    ModifyDBInstanceCommand: client_rds_1.ModifyDBInstanceCommand,
    ModifyDBParameterGroupCommand: client_rds_1.ModifyDBParameterGroupCommand,
    ModifyDBProxyCommand: client_rds_1.ModifyDBProxyCommand,
    ModifyDBProxyEndpointCommand: client_rds_1.ModifyDBProxyEndpointCommand,
    ModifyDBProxyTargetGroupCommand: client_rds_1.ModifyDBProxyTargetGroupCommand,
    ModifyDBRecommendationCommand: client_rds_1.ModifyDBRecommendationCommand,
    ModifyDBShardGroupCommand: client_rds_1.ModifyDBShardGroupCommand,
    ModifyDBSnapshotCommand: client_rds_1.ModifyDBSnapshotCommand,
    ModifyDBSnapshotAttributeCommand: client_rds_1.ModifyDBSnapshotAttributeCommand,
    ModifyDBSubnetGroupCommand: client_rds_1.ModifyDBSubnetGroupCommand,
    ModifyEventSubscriptionCommand: client_rds_1.ModifyEventSubscriptionCommand,
    ModifyGlobalClusterCommand: client_rds_1.ModifyGlobalClusterCommand,
    ModifyIntegrationCommand: client_rds_1.ModifyIntegrationCommand,
    ModifyOptionGroupCommand: client_rds_1.ModifyOptionGroupCommand,
    ModifyTenantDatabaseCommand: client_rds_1.ModifyTenantDatabaseCommand,
    PromoteReadReplicaCommand: client_rds_1.PromoteReadReplicaCommand,
    PromoteReadReplicaDBClusterCommand: client_rds_1.PromoteReadReplicaDBClusterCommand,
    PurchaseReservedDBInstancesOfferingCommand: client_rds_1.PurchaseReservedDBInstancesOfferingCommand,
    RebootDBClusterCommand: client_rds_1.RebootDBClusterCommand,
    RebootDBInstanceCommand: client_rds_1.RebootDBInstanceCommand,
    RebootDBShardGroupCommand: client_rds_1.RebootDBShardGroupCommand,
    RegisterDBProxyTargetsCommand: client_rds_1.RegisterDBProxyTargetsCommand,
    RemoveFromGlobalClusterCommand: client_rds_1.RemoveFromGlobalClusterCommand,
    RemoveRoleFromDBClusterCommand: client_rds_1.RemoveRoleFromDBClusterCommand,
    RemoveRoleFromDBInstanceCommand: client_rds_1.RemoveRoleFromDBInstanceCommand,
    RemoveSourceIdentifierFromSubscriptionCommand: client_rds_1.RemoveSourceIdentifierFromSubscriptionCommand,
    RemoveTagsFromResourceCommand: client_rds_1.RemoveTagsFromResourceCommand,
    ResetDBClusterParameterGroupCommand: client_rds_1.ResetDBClusterParameterGroupCommand,
    ResetDBParameterGroupCommand: client_rds_1.ResetDBParameterGroupCommand,
    RestoreDBClusterFromS3Command: client_rds_1.RestoreDBClusterFromS3Command,
    RestoreDBClusterFromSnapshotCommand: client_rds_1.RestoreDBClusterFromSnapshotCommand,
    RestoreDBClusterToPointInTimeCommand: client_rds_1.RestoreDBClusterToPointInTimeCommand,
    RestoreDBInstanceFromDBSnapshotCommand: client_rds_1.RestoreDBInstanceFromDBSnapshotCommand,
    RestoreDBInstanceFromS3Command: client_rds_1.RestoreDBInstanceFromS3Command,
    RestoreDBInstanceToPointInTimeCommand: client_rds_1.RestoreDBInstanceToPointInTimeCommand,
    RevokeDBSecurityGroupIngressCommand: client_rds_1.RevokeDBSecurityGroupIngressCommand,
    StartActivityStreamCommand: client_rds_1.StartActivityStreamCommand,
    StartDBClusterCommand: client_rds_1.StartDBClusterCommand,
    StartDBInstanceCommand: client_rds_1.StartDBInstanceCommand,
    StartDBInstanceAutomatedBackupsReplicationCommand: client_rds_1.StartDBInstanceAutomatedBackupsReplicationCommand,
    StartExportTaskCommand: client_rds_1.StartExportTaskCommand,
    StopActivityStreamCommand: client_rds_1.StopActivityStreamCommand,
    StopDBClusterCommand: client_rds_1.StopDBClusterCommand,
    StopDBInstanceCommand: client_rds_1.StopDBInstanceCommand,
    StopDBInstanceAutomatedBackupsReplicationCommand: client_rds_1.StopDBInstanceAutomatedBackupsReplicationCommand,
    SwitchoverBlueGreenDeploymentCommand: client_rds_1.SwitchoverBlueGreenDeploymentCommand,
    SwitchoverGlobalClusterCommand: client_rds_1.SwitchoverGlobalClusterCommand,
    SwitchoverReadReplicaCommand: client_rds_1.SwitchoverReadReplicaCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
exports.makeRDSService = effect_1.Effect.gen(function* () {
    const client = yield* Instance.RDSClientInstance;
    return commons_1.Service.fromClientAndCommands(client, commands, {
        errorTags: Errors_js_1.AllServiceErrors,
        resolveClientConfig: RDSServiceConfig.toRDSClientConfig,
    });
});
/**
 * @since 1.0.0
 * @category models
 */
class RDSService extends effect_1.Effect.Tag("@effect-aws/client-rds/RDSService")() {
    static defaultLayer = effect_1.Layer.effect(this, exports.makeRDSService).pipe(effect_1.Layer.provide(Instance.layer));
    static layer = (config) => effect_1.Layer.effect(this, exports.makeRDSService).pipe(effect_1.Layer.provide(Instance.layer), effect_1.Layer.provide(RDSServiceConfig.setRDSServiceConfig(config)));
    static baseLayer = (evaluate) => effect_1.Layer.effect(this, exports.makeRDSService).pipe(effect_1.Layer.provide(effect_1.Layer.effect(Instance.RDSClientInstance, effect_1.Effect.map(RDSServiceConfig.toRDSClientConfig, evaluate))));
}
exports.RDSService = RDSService;
//# sourceMappingURL=RDSService.js.map