"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toRDSClientConfig = exports.setRDSServiceConfig = exports.withRDSServiceConfig = void 0;
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Function_1 = require("effect/Function");
const GlobalValue_1 = require("effect/GlobalValue");
/**
 * @since 1.0.0
 * @category rds service config
 */
const currentRDSServiceConfig = (0, GlobalValue_1.globalValue)("@effect-aws/client-rds/currentRDSServiceConfig", () => effect_1.FiberRef.unsafeMake({}));
/**
 * @since 1.0.0
 * @category rds service config
 */
exports.withRDSServiceConfig = (0, Function_1.dual)(2, (effect, config) => effect_1.Effect.locally(effect, currentRDSServiceConfig, config));
/**
 * @since 1.0.0
 * @category rds service config
 */
const setRDSServiceConfig = (config) => effect_1.Layer.locallyScoped(currentRDSServiceConfig, config);
exports.setRDSServiceConfig = setRDSServiceConfig;
/**
 * @since 1.0.0
 * @category adapters
 */
exports.toRDSClientConfig = effect_1.Effect.gen(function* () {
    const { logger: serviceLogger, ...config } = yield* effect_1.FiberRef.get(currentRDSServiceConfig);
    const logger = serviceLogger === true
        ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.defaultServiceLogger)
        : (serviceLogger ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.make(serviceLogger)) : undefined);
    return { logger, ...config };
});
//# sourceMappingURL=RDSServiceConfig.js.map