/**
 * @since 1.0.0
 */
import { AddRoleToDBClusterCommand, AddRoleToDBInstanceCommand, AddSourceIdentifierToSubscriptionCommand, AddTagsToResourceCommand, ApplyPendingMaintenanceActionCommand, AuthorizeDBSecurityGroupIngressCommand, BacktrackDBClusterCommand, CancelExportTaskCommand, CopyDBClusterParameterGroupCommand, CopyDBClusterSnapshotCommand, CopyDBParameterGroupCommand, CopyDBSnapshotCommand, CopyOptionGroupCommand, CreateBlueGreenDeploymentCommand, CreateCustomDBEngineVersionCommand, CreateDBClusterCommand, CreateDBClusterEndpointCommand, CreateDBClusterParameterGroupCommand, CreateDBClusterSnapshotCommand, CreateDBInstanceCommand, CreateDBInstanceReadReplicaCommand, CreateDBParameterGroupCommand, CreateDBProxyCommand, CreateDBProxyEndpointCommand, CreateDBSecurityGroupCommand, CreateDBShardGroupCommand, CreateDBSnapshotCommand, CreateDBSubnetGroupCommand, CreateEventSubscriptionCommand, CreateGlobalClusterCommand, CreateIntegrationCommand, CreateOptionGroupCommand, CreateTenantDatabaseCommand, DeleteBlueGreenDeploymentCommand, DeleteCustomDBEngineVersionCommand, DeleteDBClusterAutomatedBackupCommand, DeleteDBClusterCommand, DeleteDBClusterEndpointCommand, DeleteDBClusterParameterGroupCommand, DeleteDBClusterSnapshotCommand, DeleteDBInstanceAutomatedBackupCommand, DeleteDBInstanceCommand, DeleteDBParameterGroupCommand, DeleteDBProxyCommand, DeleteDBProxyEndpointCommand, DeleteDBSecurityGroupCommand, DeleteDBShardGroupCommand, DeleteDBSnapshotCommand, DeleteDBSubnetGroupCommand, DeleteEventSubscriptionCommand, DeleteGlobalClusterCommand, DeleteIntegrationCommand, DeleteOptionGroupCommand, DeleteTenantDatabaseCommand, DeregisterDBProxyTargetsCommand, DescribeAccountAttributesCommand, DescribeBlueGreenDeploymentsCommand, DescribeCertificatesCommand, DescribeDBClusterAutomatedBackupsCommand, DescribeDBClusterBacktracksCommand, DescribeDBClusterEndpointsCommand, DescribeDBClusterParameterGroupsCommand, DescribeDBClusterParametersCommand, DescribeDBClustersCommand, DescribeDBClusterSnapshotAttributesCommand, DescribeDBClusterSnapshotsCommand, DescribeDBEngineVersionsCommand, DescribeDBInstanceAutomatedBackupsCommand, DescribeDBInstancesCommand, DescribeDBLogFilesCommand, DescribeDBParameterGroupsCommand, DescribeDBParametersCommand, DescribeDBProxiesCommand, DescribeDBProxyEndpointsCommand, DescribeDBProxyTargetGroupsCommand, DescribeDBProxyTargetsCommand, DescribeDBRecommendationsCommand, DescribeDBSecurityGroupsCommand, DescribeDBShardGroupsCommand, DescribeDBSnapshotAttributesCommand, DescribeDBSnapshotsCommand, DescribeDBSnapshotTenantDatabasesCommand, DescribeDBSubnetGroupsCommand, DescribeEngineDefaultClusterParametersCommand, DescribeEngineDefaultParametersCommand, DescribeEventCategoriesCommand, DescribeEventsCommand, DescribeEventSubscriptionsCommand, DescribeExportTasksCommand, DescribeGlobalClustersCommand, DescribeIntegrationsCommand, DescribeOptionGroupOptionsCommand, DescribeOptionGroupsCommand, DescribeOrderableDBInstanceOptionsCommand, DescribePendingMaintenanceActionsCommand, DescribeReservedDBInstancesCommand, DescribeReservedDBInstancesOfferingsCommand, DescribeSourceRegionsCommand, DescribeTenantDatabasesCommand, DescribeValidDBInstanceModificationsCommand, DisableHttpEndpointCommand, DownloadDBLogFilePortionCommand, EnableHttpEndpointCommand, FailoverDBClusterCommand, FailoverGlobalClusterCommand, ListTagsForResourceCommand, ModifyActivityStreamCommand, ModifyCertificatesCommand, ModifyCurrentDBClusterCapacityCommand, ModifyCustomDBEngineVersionCommand, ModifyDBClusterCommand, ModifyDBClusterEndpointCommand, ModifyDBClusterParameterGroupCommand, ModifyDBClusterSnapshotAttributeCommand, ModifyDBInstanceCommand, ModifyDBParameterGroupCommand, ModifyDBProxyCommand, ModifyDBProxyEndpointCommand, ModifyDBProxyTargetGroupCommand, ModifyDBRecommendationCommand, ModifyDBShardGroupCommand, ModifyDBSnapshotAttributeCommand, ModifyDBSnapshotCommand, ModifyDBSubnetGroupCommand, ModifyEventSubscriptionCommand, ModifyGlobalClusterCommand, ModifyIntegrationCommand, ModifyOptionGroupCommand, ModifyTenantDatabaseCommand, PromoteReadReplicaCommand, PromoteReadReplicaDBClusterCommand, PurchaseReservedDBInstancesOfferingCommand, RebootDBClusterCommand, RebootDBInstanceCommand, RebootDBShardGroupCommand, RegisterDBProxyTargetsCommand, RemoveFromGlobalClusterCommand, RemoveRoleFromDBClusterCommand, RemoveRoleFromDBInstanceCommand, RemoveSourceIdentifierFromSubscriptionCommand, RemoveTagsFromResourceCommand, ResetDBClusterParameterGroupCommand, ResetDBParameterGroupCommand, RestoreDBClusterFromS3Command, RestoreDBClusterFromSnapshotCommand, RestoreDBClusterToPointInTimeCommand, RestoreDBInstanceFromDBSnapshotCommand, RestoreDBInstanceFromS3Command, RestoreDBInstanceToPointInTimeCommand, RevokeDBSecurityGroupIngressCommand, StartActivityStreamCommand, StartDBClusterCommand, StartDBInstanceAutomatedBackupsReplicationCommand, StartDBInstanceCommand, StartExportTaskCommand, StopActivityStreamCommand, StopDBClusterCommand, StopDBInstanceAutomatedBackupsReplicationCommand, StopDBInstanceCommand, SwitchoverBlueGreenDeploymentCommand, SwitchoverGlobalClusterCommand, SwitchoverReadReplicaCommand, } from "@aws-sdk/client-rds";
import { Service } from "@effect-aws/commons";
import { Effect, Layer } from "effect";
import { AllServiceErrors } from "./Errors.js";
import * as Instance from "./RDSClientInstance.js";
import * as RDSServiceConfig from "./RDSServiceConfig.js";
const commands = {
    AddRoleToDBClusterCommand,
    AddRoleToDBInstanceCommand,
    AddSourceIdentifierToSubscriptionCommand,
    AddTagsToResourceCommand,
    ApplyPendingMaintenanceActionCommand,
    AuthorizeDBSecurityGroupIngressCommand,
    BacktrackDBClusterCommand,
    CancelExportTaskCommand,
    CopyDBClusterParameterGroupCommand,
    CopyDBClusterSnapshotCommand,
    CopyDBParameterGroupCommand,
    CopyDBSnapshotCommand,
    CopyOptionGroupCommand,
    CreateBlueGreenDeploymentCommand,
    CreateCustomDBEngineVersionCommand,
    CreateDBClusterCommand,
    CreateDBClusterEndpointCommand,
    CreateDBClusterParameterGroupCommand,
    CreateDBClusterSnapshotCommand,
    CreateDBInstanceCommand,
    CreateDBInstanceReadReplicaCommand,
    CreateDBParameterGroupCommand,
    CreateDBProxyCommand,
    CreateDBProxyEndpointCommand,
    CreateDBSecurityGroupCommand,
    CreateDBShardGroupCommand,
    CreateDBSnapshotCommand,
    CreateDBSubnetGroupCommand,
    CreateEventSubscriptionCommand,
    CreateGlobalClusterCommand,
    CreateIntegrationCommand,
    CreateOptionGroupCommand,
    CreateTenantDatabaseCommand,
    DeleteBlueGreenDeploymentCommand,
    DeleteCustomDBEngineVersionCommand,
    DeleteDBClusterCommand,
    DeleteDBClusterAutomatedBackupCommand,
    DeleteDBClusterEndpointCommand,
    DeleteDBClusterParameterGroupCommand,
    DeleteDBClusterSnapshotCommand,
    DeleteDBInstanceCommand,
    DeleteDBInstanceAutomatedBackupCommand,
    DeleteDBParameterGroupCommand,
    DeleteDBProxyCommand,
    DeleteDBProxyEndpointCommand,
    DeleteDBSecurityGroupCommand,
    DeleteDBShardGroupCommand,
    DeleteDBSnapshotCommand,
    DeleteDBSubnetGroupCommand,
    DeleteEventSubscriptionCommand,
    DeleteGlobalClusterCommand,
    DeleteIntegrationCommand,
    DeleteOptionGroupCommand,
    DeleteTenantDatabaseCommand,
    DeregisterDBProxyTargetsCommand,
    DescribeAccountAttributesCommand,
    DescribeBlueGreenDeploymentsCommand,
    DescribeCertificatesCommand,
    DescribeDBClusterAutomatedBackupsCommand,
    DescribeDBClusterBacktracksCommand,
    DescribeDBClusterEndpointsCommand,
    DescribeDBClusterParameterGroupsCommand,
    DescribeDBClusterParametersCommand,
    DescribeDBClusterSnapshotAttributesCommand,
    DescribeDBClusterSnapshotsCommand,
    DescribeDBClustersCommand,
    DescribeDBEngineVersionsCommand,
    DescribeDBInstanceAutomatedBackupsCommand,
    DescribeDBInstancesCommand,
    DescribeDBLogFilesCommand,
    DescribeDBParameterGroupsCommand,
    DescribeDBParametersCommand,
    DescribeDBProxiesCommand,
    DescribeDBProxyEndpointsCommand,
    DescribeDBProxyTargetGroupsCommand,
    DescribeDBProxyTargetsCommand,
    DescribeDBRecommendationsCommand,
    DescribeDBSecurityGroupsCommand,
    DescribeDBShardGroupsCommand,
    DescribeDBSnapshotAttributesCommand,
    DescribeDBSnapshotTenantDatabasesCommand,
    DescribeDBSnapshotsCommand,
    DescribeDBSubnetGroupsCommand,
    DescribeEngineDefaultClusterParametersCommand,
    DescribeEngineDefaultParametersCommand,
    DescribeEventCategoriesCommand,
    DescribeEventSubscriptionsCommand,
    DescribeEventsCommand,
    DescribeExportTasksCommand,
    DescribeGlobalClustersCommand,
    DescribeIntegrationsCommand,
    DescribeOptionGroupOptionsCommand,
    DescribeOptionGroupsCommand,
    DescribeOrderableDBInstanceOptionsCommand,
    DescribePendingMaintenanceActionsCommand,
    DescribeReservedDBInstancesCommand,
    DescribeReservedDBInstancesOfferingsCommand,
    DescribeSourceRegionsCommand,
    DescribeTenantDatabasesCommand,
    DescribeValidDBInstanceModificationsCommand,
    DisableHttpEndpointCommand,
    DownloadDBLogFilePortionCommand,
    EnableHttpEndpointCommand,
    FailoverDBClusterCommand,
    FailoverGlobalClusterCommand,
    ListTagsForResourceCommand,
    ModifyActivityStreamCommand,
    ModifyCertificatesCommand,
    ModifyCurrentDBClusterCapacityCommand,
    ModifyCustomDBEngineVersionCommand,
    ModifyDBClusterCommand,
    ModifyDBClusterEndpointCommand,
    ModifyDBClusterParameterGroupCommand,
    ModifyDBClusterSnapshotAttributeCommand,
    ModifyDBInstanceCommand,
    ModifyDBParameterGroupCommand,
    ModifyDBProxyCommand,
    ModifyDBProxyEndpointCommand,
    ModifyDBProxyTargetGroupCommand,
    ModifyDBRecommendationCommand,
    ModifyDBShardGroupCommand,
    ModifyDBSnapshotCommand,
    ModifyDBSnapshotAttributeCommand,
    ModifyDBSubnetGroupCommand,
    ModifyEventSubscriptionCommand,
    ModifyGlobalClusterCommand,
    ModifyIntegrationCommand,
    ModifyOptionGroupCommand,
    ModifyTenantDatabaseCommand,
    PromoteReadReplicaCommand,
    PromoteReadReplicaDBClusterCommand,
    PurchaseReservedDBInstancesOfferingCommand,
    RebootDBClusterCommand,
    RebootDBInstanceCommand,
    RebootDBShardGroupCommand,
    RegisterDBProxyTargetsCommand,
    RemoveFromGlobalClusterCommand,
    RemoveRoleFromDBClusterCommand,
    RemoveRoleFromDBInstanceCommand,
    RemoveSourceIdentifierFromSubscriptionCommand,
    RemoveTagsFromResourceCommand,
    ResetDBClusterParameterGroupCommand,
    ResetDBParameterGroupCommand,
    RestoreDBClusterFromS3Command,
    RestoreDBClusterFromSnapshotCommand,
    RestoreDBClusterToPointInTimeCommand,
    RestoreDBInstanceFromDBSnapshotCommand,
    RestoreDBInstanceFromS3Command,
    RestoreDBInstanceToPointInTimeCommand,
    RevokeDBSecurityGroupIngressCommand,
    StartActivityStreamCommand,
    StartDBClusterCommand,
    StartDBInstanceCommand,
    StartDBInstanceAutomatedBackupsReplicationCommand,
    StartExportTaskCommand,
    StopActivityStreamCommand,
    StopDBClusterCommand,
    StopDBInstanceCommand,
    StopDBInstanceAutomatedBackupsReplicationCommand,
    SwitchoverBlueGreenDeploymentCommand,
    SwitchoverGlobalClusterCommand,
    SwitchoverReadReplicaCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
export const makeRDSService = Effect.gen(function* () {
    const client = yield* Instance.RDSClientInstance;
    return Service.fromClientAndCommands(client, commands, {
        errorTags: AllServiceErrors,
        resolveClientConfig: RDSServiceConfig.toRDSClientConfig,
    });
});
/**
 * @since 1.0.0
 * @category models
 */
export class RDSService extends Effect.Tag("@effect-aws/client-rds/RDSService")() {
    static defaultLayer = Layer.effect(this, makeRDSService).pipe(Layer.provide(Instance.layer));
    static layer = (config) => Layer.effect(this, makeRDSService).pipe(Layer.provide(Instance.layer), Layer.provide(RDSServiceConfig.setRDSServiceConfig(config)));
    static baseLayer = (evaluate) => Layer.effect(this, makeRDSService).pipe(Layer.provide(Layer.effect(Instance.RDSClientInstance, Effect.map(RDSServiceConfig.toRDSClientConfig, evaluate))));
}
//# sourceMappingURL=RDSService.js.map